const phrases = [
  'Crie quantas lojas precisar',
  'Integração com +20 gateway`s',
  'Upsell One Click',
];

const typingSpeed = 150; // Velocidade da digitação
const pauseBetweenPhrases = 1000; // Pausa entre as frases em milissegundos
let phraseIndex = 0;
let charIndex = 0;

function type() {
  if (charIndex < phrases[phraseIndex].length) {
    document.getElementById('typing-effect').innerHTML +=
      phrases[phraseIndex].charAt(charIndex);
    charIndex++;
    setTimeout(type, typingSpeed);
  } else {
    setTimeout(erase, pauseBetweenPhrases); // Espera antes de apagar
  }
}

function erase() {
  if (charIndex > 0) {
    document.getElementById('typing-effect').innerHTML = phrases[
      phraseIndex
    ].substring(0, charIndex - 1);
    charIndex--;
    setTimeout(erase, typingSpeed / 2); // Apagar mais rápido que digitar
  } else {
    phraseIndex = (phraseIndex + 1) % phrases.length; // Vai para a próxima frase
    setTimeout(type, typingSpeed);
  }
}

// Iniciar o efeito de digitação
type();

const verSenha = document.querySelector('.btn-ver-senha');

verSenha.addEventListener('click', () => {
  const inputSenha = document.querySelector('#input-senha');
  if (inputSenha.getAttribute('type') === 'password') {
    inputSenha.setAttribute('type', 'text');
  } else {
    inputSenha.setAttribute('type', 'password');
  }
});

const inputEmail = document.querySelector('#input-email');
const inputSenha = document.querySelector('#input-senha');

inputEmail.addEventListener('blur', () => {
  // Verifica se o input está vazio
  if (inputEmail.value.trim() === '') {
    inputEmail.parentElement.classList.add('erro'); // Adiciona a classe de erro
    document.querySelector('#p-erro-email').classList.add('ativo');
  } else {
    inputEmail.parentElement.classList.remove('erro'); // Remove a classe de erro se preenchido
    document.querySelector('#p-erro-email').classList.remove('ativo');
    document.querySelector('#p-erro-senha').classList.remove('ativo');
  }
});

inputSenha.addEventListener('blur', () => {
  inputSenha.parentElement.classList.remove('erro');
  document.querySelector('#p-erro-senha').classList.remove('ativo');
});

/* FUNCAO LOGIN */
document
  .querySelector('#form-login')
  .addEventListener('submit', function (event) {
    event.preventDefault();

    const inputEmail = document.querySelector('#input-email');
    const inputSenha = document.querySelector('#input-senha');

    const loginData = {
      username: inputEmail.value,
      password: inputSenha.value,
    };

    if (!inputEmail.value) {
      inputEmail.parentElement.parentElement.classList.add('erro');
    } else {
      inputEmail.parentElement.parentElement.classList.remove('erro');
    }

    if (!inputSenha.value) {
      inputSenha.parentElement.parentElement.classList.add('erro');
    } else {
      inputSenha.parentElement.parentElement.classList.remove('erro');
    }

    if (inputEmail.value && inputSenha.value) fazerLogin(loginData);
  });

function fazerLogin(usuario) {
  axios
    .post(
      'https://checkout-checkout-api.xwcabj.easypanel.host/auth/login',
      usuario,
    )
    .then((response) => {
      window.location = '/home?token=' + response.data.accessToken;
    })
    .catch((error) => {
      document.querySelector('#p-erro-senha').classList.add('ativo');
      inputSenha.parentElement.classList.add('erro');
    });
}
