let dataTransations;

const filtrosAvancados = document.querySelector('#div-filtros-avancados');
const btnfiltrosAvancados = document.querySelector('.btn-filtros-avancados');

btnfiltrosAvancados.addEventListener('click', () => {
  if (!filtrosAvancados.classList.contains('ativo')) {
    filtrosAvancados.classList.add('ativo');
    filtrosAvancados.classList.remove('disabled');
  } else {
    filtrosAvancados.classList.remove('ativo');
    filtrosAvancados.classList.add('disabled');
  }
  btnfiltrosAvancados.classList.toggle('ativo');
});

const btn = document.querySelector('#modal-detalhes');

function abrirModal(idModal, data) {
  fecharModais();

  if (data) infoModal(data);

  document.getElementById(idModal).classList.add('ativo');
}

function fecharModais() {
  const modais = document.querySelectorAll('.modal-container');
  modais.forEach((elem) => elem.classList.remove('ativo'));
}

function infoModal(data) {
  data = JSON.parse(data.replace("\\'", /'/g).replace('&quot;', /"/g));
  document.querySelector('#span-tansaction').textContent = data.externalId;
  document.querySelector('.p-forma-pagamento').innerHTML = data.paidAt
    ? `Pagamento via PIX em <span id="span-data-pagamento">${formatDate(
        data.paidAt,
      )}</span>`
    : '';
  document.querySelector('#span-status').innerHTML =
    data.status == 'paid' || data.status == 'PAID'
      ? '<p>APROVADO</p>'
      : '<p>PENDENTE</p>';
  document.querySelector(
    '#span-status',
  ).classList = `content-status content-status-${
    data.status == 'paid' || data.status == 'PAID' ? 'aprovado' : 'pendente'
  }`;

  document.querySelector('#span-date').innerHTML = formatDate(data.createdAt);
  document.querySelector('#span-productname').textContent = data.item;
  document.querySelector('#span-quantity').textContent = '1';
  document.querySelector('#span-amount').textContent = (
    parseFloat(data.itemPrice) / 100
  ).toLocaleString('pt-BR', {
    minimumFractionDigits: 2,
    maximumFractionDigits: 2,
  });
  document.querySelector('#span-tranckingCode').textContent = data.trackingCode;
  document.querySelector('#span-tax').textContent = (
    parseFloat(data.amount) / 100
  ).toLocaleString('pt-BR', {
    minimumFractionDigits: 2,
    maximumFractionDigits: 2,
  });

  document.querySelector('.p-nomeCompleto').textContent = formatarTelefone(
    data.customer,
  );
  document.querySelector('.p-phoneNumber').textContent = formatarTelefone(
    data.phoneNumber,
  );
  document.querySelector('.p-email').textContent = data.email;
  document.querySelector('.p-cpf').textContent = `CPF: ${data.cpf}`;

  document.querySelector('.p-street').textContent = `Endereço: ${data.street}`;
  document.querySelector(
    '.p-streetNumber',
  ).textContent = `Numero: ${data.streetNumber}`;
  document.querySelector('.p-complement').textContent =
    data.complement && data.complement != 'Complemento não disponível'
      ? `Complemento: ${data.complement}`
      : '';
  document.querySelector(
    '.p-neighborhood',
  ).textContent = `Bairro: ${data.neighborhood}`;
  document.querySelector(
    '.p-postalCode',
  ).textContent = `CEP: ${data.postalCode}`;
  document.querySelector('.p-city').textContent = `Cidade: ${data.city}`;

  document.querySelector('#span-utm-source').textContent = data.utmSource
    ? `${data.utmSource}`
    : '';
  document.querySelector('#span-utm-medium').textContent = data.utmMedium
    ? `${data.utmMedium}`
    : '';
  document.querySelector('#span-utm-campaign').textContent = data.utmCampaign
    ? `${data.utmCampaign}`
    : '';
  document.querySelector('#span-utm-term').textContent = data.utmTerm
    ? `${data.utmTerm}`
    : '';
  document.querySelector('#span-utm-content').textContent = data.utmContent
    ? `${data.utmContent}`
    : '';

  console.log(data);
}

document.addEventListener('click', (ev) => {
  if (ev.target.classList.contains('modal-container')) fecharModais();
});

const btnLimparFiltros = document.querySelector('.btn-limpar-filtro');

btnLimparFiltros.addEventListener('click', () => {
  const inputsForm = document.querySelectorAll('form input');
  const selectsForm = document.querySelectorAll('form select');

  inputsForm.forEach((elem) => (elem.value = ''));
  selectsForm.forEach((elem) =>
    elem.querySelector('option').setAttribute('selected', 'true'),
  );
});

function getTransactions() {
  abrirModal('modal-loader');
  axios
    .get(
      'https://recupera-fly-main-api.xwcabj.easypanel.host/recuperafly/transaction',
      {
        headers: {
          Authorization: `Bearer ${localStorage.getItem(
            'authTokenRecuperaFly',
          )}`,
          'Content-Type': 'application/json',
        },
      },
    )
    .then((response) => {
      fecharModais();
      dataTransations = response.data.sort(
        (a, b) => new Date(b.createdAt) - new Date(a.createdAt),
      );

      let totalVendas = dataTransations.reduce(
        (sum, item) =>
          item.netAmount !== '' ? sum + parseFloat(item.netAmount) / 100 : sum,
        0,
      );
      let qntdVendas = dataTransations.filter(
        (elem) => elem.netAmount != '',
      ).length;
      renderTable(currentPage, dataTransations);
      document.querySelector(
        '#span-total-vendas',
      ).textContent = `R$ ${totalVendas.toLocaleString('pt-BR', {
        minimumFractionDigits: 2,
        maximumFractionDigits: 2,
      })}`;
      document.querySelector(
        '#span-quantidade-vendas',
      ).textContent = `${qntdVendas}`;
      document.querySelector('#span-ticket-medio').textContent = `R$ ${(
        totalVendas / qntdVendas
      )
        .toFixed(2)
        .replace('.', ',')}`;
    })
    .catch((error) => {
      console.error(error);
    });
}

if (localStorage.getItem('authTokenVanillaCheckout')) {
  getTransactions();
} else {
  document.querySelector('body').style.display = 'none';
}

function createTableTransations(data) {
  const table = document.querySelector('#table-vendas-disparos tbody');
  table.innerHTML = '';
  data.forEach((elem) => {
    const tr = document.createElement('tr');
    tr.innerHTML = `
      <td>${elem.externalId}</td>
      <td>${sliceString(elem.title)}</td>
      <td>${sliceString(elem.customer)}</td>
      <td class="content-pagamento"><img src="img/visa.png" /></td>
      <td class="content-status content-status-${
        elem.status == 'paid' || elem.status == 'PAID' ? 'aprovado' : 'pendente'
      }"><p>${
      elem.status == 'paid' || elem.status == 'PAID' ? 'APROVADO' : 'PENDENTE'
    }</p></td>
      <td>${elem.createdAt ? formatDate(elem.createdAt) : ''}</td>
      <td>${elem.paidAt ? formatDate(elem.paidAt) : ''}</span></td>
      <td class="p-valor">R$ ${(
        parseFloat(elem.netAmount) / 100
      ).toLocaleString('pt-BR', {
        minimumFractionDigits: 2,
        maximumFractionDigits: 2,
      })}</td>
      <td class="content-btn-ver-vendas"><a class="btn-ver-venda" onclick="abrirModal('modal-detalhes', '${JSON.stringify(
        elem,
      )
        .replace(/'/g, "\\'")
        .replace(
          /"/g,
          '&quot;',
        )}')"><img src="img/icon-password.svg" /></a></td>
    `;
    table.appendChild(tr);
  });
}

function formatDate(date) {
  const isoString = new Date(date);

  isoString.setHours(isoString.getHours() - 3);

  const datePart = isoString.toISOString().split('T')[0];
  const timePart = isoString.toISOString().split('T')[1].split('.')[0];

  // Reformatar a data para "DD/MM/YYYY"
  const [year, month, day] = datePart.split('-');

  return `${day}/${month}/${year} <span>${timePart}</span>`;
}

function formatarTelefone(numero) {
  const regex = /^(\d{2})(\d{5})(\d{4})$/;
  return numero.replace(regex, '($1) $2-$3');
}

function sliceString(string) {
  if (string.length < 13) return string;
  else {
    return string.slice(0, 12) + '...';
  }
}

// Configurações de paginação
const rowsPerPage = 20;
let currentPage = 1;

// Elementos DOM
const paginationContainer = document.getElementById('pagination');

// Função para renderizar a tabela
function renderTable(page, data) {
  const startIndex = (page - 1) * rowsPerPage;
  const endIndex = startIndex + rowsPerPage;

  const rows = data.slice(startIndex, endIndex);

  const totalPages = Math.ceil(data.length / rowsPerPage);

  createTableTransations(rows);
  renderPagination(totalPages, data);
}

// Função para criar paginação com elipses
function renderPagination(totalPages, data) {
  paginationContainer.innerHTML = ''; // Limpa a paginação

  const delta = 2; // Mostra 2 botões antes e depois da página atual
  const range = [];
  const rangeWithDots = [];
  let l;

  for (let i = 1; i <= totalPages; i++) {
    if (
      i === 1 ||
      i === totalPages ||
      (i >= currentPage - delta && i <= currentPage + delta)
    ) {
      range.push(i);
    }
  }

  // Cria elipses
  for (let i of range) {
    if (l) {
      if (i - l === 2) {
        rangeWithDots.push(l + 1);
      } else if (i - l !== 1) {
        rangeWithDots.push('...');
      }
    }
    rangeWithDots.push(i);
    l = i;
  }

  // Renderiza os botões da paginação
  rangeWithDots.forEach((i) => {
    const button = document.createElement('button');
    if (i === '...') {
      button.textContent = i;
      button.disabled = true;
    } else {
      button.textContent = i;
      button.classList = i === currentPage ? 'active' : '';
      button.addEventListener('click', () => {
        currentPage = i;
        renderTable(currentPage, data);
        renderPagination(totalPages, data);
      });
    }
    paginationContainer.appendChild(button);
  });
}

/* FILTROS */
const inputsFilter = document.querySelectorAll(
  '#form-filtros input, #form-filtros select',
);
const formFiltros = document.querySelector('#form-filtros');
formFiltros.addEventListener('submit', (ev) => {
  ev.preventDefault();

  abrirModal('modal-loader');
  let dataFilter = dataTransations;

  let inputsResult = Array.from(inputsFilter).filter((elem) => elem.value);

  let [dateStart, dateEnd] = document
    .querySelector('#input-date-filtro')
    .value.split(' - ');

  inputsResult.forEach((elem) => {
    if (elem.dataset.filtro !== 'createdAt') {
      if (elem.dataset.filtro == 'customer' || elem.dataset.filtro == 'email') {
        dataFilter = dataFilter.filter((element) =>
          element[elem.dataset.filtro]
            ? element[elem.dataset.filtro]
                .toLowerCase()
                .includes(elem.value.toLowerCase())
            : false,
        );
      } else {
        dataFilter = dataFilter.filter((element) =>
          element[elem.dataset.filtro]
            ? element[elem.dataset.filtro] == elem.value
            : false,
        );
      }
    } else {
      const [dayStart, monthStart, yearStart] = dateStart.split('/');
      const [dayEnd, monthEnd, yearEnd] = dateEnd.split('/');

      dataFilter = dataFilter.filter((element) => {
        if (dateStart == dateEnd) {
          return (
            new Date(element[elem.dataset.filtro]).setHours(0, 0, 0, 0) ==
            new Date(yearStart, monthStart - 1, dayStart).setHours(0, 0, 0, 0)
          );
        } else {
          return (
            new Date(element[elem.dataset.filtro]).setHours(0, 0, 0, 0) >=
              new Date(yearStart, monthStart - 1, dayStart).setHours(
                0,
                0,
                0,
                0,
              ) &&
            new Date(element[elem.dataset.filtro]).setHours(0, 0, 0, 0) <=
              new Date(yearEnd, monthEnd - 1, dayEnd).setHours(0, 0, 0, 0)
          );
        }
      });
    }
  });

  let totalVendas = dataFilter.reduce(
    (sum, item) =>
      item.netAmount != '' ? sum + parseFloat(item.netAmount) / 100 : sum,
    0,
  );
  let qntdVendas = dataFilter.filter((elem) => elem.netAmount != '').length;

  document.querySelector(
    '#span-total-vendas',
  ).textContent = `R$ ${totalVendas.toLocaleString('pt-BR', {
    minimumFractionDigits: 2,
    maximumFractionDigits: 2,
  })}`;
  document.querySelector(
    '#span-quantidade-vendas',
  ).textContent = `${qntdVendas}`;
  document.querySelector('#span-ticket-medio').textContent =
    dataFilter.length > 0
      ? `R$ ${(totalVendas / qntdVendas).toFixed(2).replace('.', ',')}`
      : 'R$ 0';

  createTableTransations(dataFilter);
  const totalPages = Math.ceil(dataFilter.length / rowsPerPage);
  renderPagination(totalPages, dataFilter);

  setTimeout(fecharModais, 1000);
});

document.querySelector('.btn-limpar-filtro').addEventListener('click', () => {
  inputsFilter.forEach((elem) => (elem.value = ''));

  let today = new Date();
  let daysAgo = new Date();

  daysAgo.setDate(daysAgo.getDate() - 6);

  document.querySelector(
    '#input-date-filtro',
  ).value = `${daysAgo.toLocaleDateString()} - ${today.getDate()}/${
    today.getMonth() + 1
  }/${today.getFullYear()}`;
});


// const obg = {
//   logo: "https://examaple.com/diretorio-da-imagem.png",
//   alinhamento: "left",
//   colorBarraAvisos: "#FFFFFF",
//   backgroundColorBarraAvisos: "#000000",
//   textoAvisos: "Exemplo de texto de avisos",
//   colorTextoDesconto: "#FFFFFF",
//   colorTextoTemporizador: "#FFFFFF",
//   exibirCarrinho: true,
//   colorEtapas: "#FFFFFF",
//   colorBtnsEtapas: "#FFFFFF",
//   backgroundColorBtnsEtapas: "#000000",
//   colorBtnFinalizarCompra: "#FFFFFF",
//   backgroundColorBtnFinalizarCompra: "#000000",
//   exibirNomeLoja: true,
//   exibirFormasPagamento: true,
//   exibirCgc: true,
//   exibirEmailContato: true,
//   exibirEndereco: true,
// }

