document.getElementById("input-cep").addEventListener("input", () => {
  const cep = document.getElementById("input-cep");

  if(cep.value.length == 9 ){
    document.querySelector('.img-load-cep').classList.add('ativo');

    const cepLimpo = cep.value.trim().replace("-", "");

    setTimeout(() => {
      fetch(`https://viacep.com.br/ws/${cepLimpo}/json/`)
        .then((response) => {
          if (!response.ok) {
            throw new Error("Erro na consulta do CEP!");
          }
          return response.json();
        })
        .then((data) => {
          if (data.erro) {
            // document.querySelector('.input-group-cep').classList.add('right-input');
            document.querySelector('.img-load-cep').classList.remove('ativo');

            const inputs = document.querySelectorAll('.section-form.ativo input:not([type="checkbox"]):not([type="radio"]):not(:disabled):not([data-require="false"])')

            inputs.forEach(elem=> {
              elem.value = elem.id != 'input-cep' ? '' : elem.value;
              elem.parentElement.classList.add('error-input')
            });
            
            // document.querySelector('#input-numero').focus()
            document.querySelector('#input-numero').parentElement.classList.remove("error-input")
            return;
          }

          document.querySelector('.input-group-cep').classList.remove('error-input-cep');
          
          document.getElementById("input-endereco").value = data.logradouro;
          document.getElementById("input-bairro").value = data.bairro;
          document.getElementById("input-cidade").value = data.localidade;
          document.getElementById("input-estado").value = data.uf;
          
          document.querySelector('.img-load-cep').classList.remove('ativo');

          document.querySelector('#info-segura-frete').classList.remove('ativo');
          document.querySelector('.shipping-option').classList.add('ativo');
          document.querySelectorAll('.section-form.ativo input').forEach(elem => {
            if(elem.value !== '' || (elem.value !== '' && elem.dataset.require == 'false')) {
              elem.parentElement.classList.add('right-input')
              elem.parentElement.classList.remove('error-input');
            } else if(elem.value === '' && elem.dataset.require !== 'false') {
              elem.parentElement.classList.remove('right-input')
              elem.parentElement.classList.add('error-input');
            }

            if(elem.dataset.require == 'false') {
              elem.parentElement.classList.remove('right-input');
              elem.parentElement.classList.remove('error-input');
            }
          });

          document.querySelector('#valor-frete-cart').innerText = "R$ " + document.querySelector('.checked .price-frete').textContent;
          document.querySelector('#valor-total-cart').textContent = document.querySelector('#valor-frete-cart').textContent == '-' ? parseFloat(document.querySelector('#valor-subtotal-cart').textContent.replace(',', '.')).toFixed(2).replace('.', ',') : (parseFloat(document.querySelector('#valor-subtotal-cart').textContent.replace(',', '.')) + parseFloat(document.querySelector('#valor-frete-cart').textContent.replace('R$', '').replace(',', '.'))).toFixed(2).replace('.', ',').replace('R$', '');
        })
        .catch((error) => {
          console.error(error);
          document.querySelector('#info-segura-frete').classList.add('ativo');
          document.querySelector('.shipping-option').classList.remove('ativo');
          document.querySelector('.input-group-cep').classList.add('error-input-cep');
        });
    }, 250);

    document.querySelector(".div-endereco-completo").classList.add('section-active');
  }
});
