const inputsFrete = document.querySelectorAll('.radio-option input');

inputsFrete.forEach((elem) => {
  elem.addEventListener('change', () => {
    inputsFrete.forEach((elem1) =>
      elem1.parentElement.classList.remove('checked'),
    );

    if (elem.checked) elem.parentElement.classList.add('checked');
    else elem.parentElement.classList.remove('checked');

    document.querySelector('#valor-frete-cart').innerText = parseFloat(
      document.querySelector('.checked .price-frete').textContent,
    )
      ? 'R$ ' + document.querySelector('.checked .price-frete').textContent
      : '-';

    document.querySelector('#valor-total-cart').textContent =
      document.querySelector('#valor-frete-cart').textContent == '-'
        ? parseFloat(
            document
              .querySelector('#valor-subtotal-cart')
              .textContent.replace(',', '.'),
          )
            .toFixed(2)
            .replace('.', ',')
        : (
            parseFloat(
              document
                .querySelector('#valor-subtotal-cart')
                .textContent.replace(',', '.'),
            ) +
            parseFloat(
              document
                .querySelector('#valor-frete-cart')
                .textContent.replace('R$', '')
                .replace(',', '.'),
            )
          )
            .toFixed(2)
            .replace('.', ',')
            .replace('R$', '');

    document.querySelector('#valor-desconto-pix').textContent = (
      parseFloat(
        document
          .querySelector('#valor-subtotal-cart')
          .textContent.replace(',', '.'),
      ) * 0.05
    )
      .toFixed(2)
      .replace('.', ',');

    document.querySelector('#valor-total-cart-header').textContent =
      document.querySelector('#valor-total-cart').textContent;
  });
});

function changeContent(num) {
  let contentActive;
  const sections = document.querySelectorAll('.section-form');

  sections.forEach((elem, i) => {
    if (elem.classList.contains('ativo')) {
      contentActive = i;
      elem.classList.remove('ativo');
    }
  });

  const tabs = document.querySelectorAll(
    '.content-tabs .step-indicator-container',
  );
  tabs.forEach((elem) => {
    elem.classList.remove('active');
    elem.classList.remove('current');
  });

  const tabsMobile = document.querySelectorAll(
    '.content-tabs-mobile .step-indicator-container',
  );
  tabsMobile.forEach((elem) => {
    elem.classList.remove('active');
    elem.classList.remove('current');
  });

  tabs.forEach((elem, i) => {
    elem.classList.remove('active');
    elem.classList.remove('current');
    if (i < num) {
      elem.classList.add('active');
    }
  });

  tabsMobile.forEach((elem, i) => {
    elem.classList.remove('active');
    elem.classList.remove('current');
    if (i < num) {
      elem.classList.add('active');
    }
  });

  sections[num].classList.add('ativo');
  tabs[num].classList.add('current');

  contentActive = num;

  // document.querySelector('.section-form.ativo input').focus();

  sections[num]
    .querySelectorAll('.error-input')
    .forEach((elem) => elem.classList.remove('error-input'));
  tabsMobile[num].classList.add('current');
}

const inputEmail = document.querySelector('#input-email');
const checkboxNoEmail = document.querySelector('#checkbox-sem-email');

checkboxNoEmail.addEventListener('change', (ev) => {
  checkDisable(checkboxNoEmail, inputEmail);
});

const inputNum = document.querySelector('#input-numero');
const checkboxNoNum = document.querySelector('#checkbox-sem-numero');
checkboxNoNum.addEventListener('change', (ev) => {
  checkDisable(checkboxNoNum, inputNum);
});

function checkDisable(checkbox, input) {
  if (checkbox.checked) {
    input.value = input.dataset.valuedisable;
    input.setAttribute('disabled', 'true');
    input.parentElement.classList.remove('error-input');
    checkbox.parentElement.classList.add('sem-dados-checked');
  } else {
    input.value = '';
    input.removeAttribute('disabled');
    checkbox.parentElement.classList.remove('sem-dados-checked');
  }
}

function containsNumbersOrSpecialChars(input) {
  // Define uma expressão regular para verificar números ou caracteres especiais, exceto espaço
  const regex = /[0-9!@#$%^&*(),.?":{}|<>_\-+=`~[\]\\;'\/]/;
  return regex.test(input.trim());
}

const emailInput = document.getElementById('input-email');
emailInput.addEventListener('blur', () => {
  const emailValido = /^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(emailInput.value);
  if (!emailValido) {
    emailInput.parentElement.classList.add('error-input');
    emailInput.parentElement.classList.remove('right-input');
  } else {
    emailInput.parentElement.classList.remove('error-input');
    emailInput.parentElement.classList.add('right-input');
  }
});

const nomeInput = document.getElementById('input-nome');
nomeInput.addEventListener('blur', () => {
  const nomeValido = nomeInput.value.trim().split(' ').length > 1;

  if (!nomeValido || containsNumbersOrSpecialChars(nomeInput.value)) {
    nomeInput.parentElement.classList.add('error-input');
    nomeInput.parentElement.classList.remove('right-input');
  } else {
    nomeInput.parentElement.classList.remove('error-input');
    nomeInput.parentElement.classList.add('right-input');
  }
});

const phoneNumInput = document.getElementById('input-telefone');
phoneNumInput.addEventListener('blur', () => {
  if (phoneNumInput.value.length !== 15) {
    phoneNumInput.parentElement.classList.add('error-input');
    phoneNumInput.parentElement.classList.remove('right-input');
  } else {
    phoneNumInput.parentElement.classList.remove('error-input');
    phoneNumInput.parentElement.classList.add('right-input');
  }
});

const cpfInput = document.getElementById('input-cpf');
cpfInput.addEventListener('blur', () => {
  const cpfValido = validarCPF(cpfInput.value);
  if (!cpfValido) {
    cpfInput.parentElement.classList.add('error-input');
    cpfInput.parentElement.classList.remove('right-input');
  } else {
    cpfInput.parentElement.classList.remove('error-input');
    cpfInput.parentElement.classList.add('right-input');
  }
});

const validadeCartao = document.getElementById('input-validade-cartao');
validadeCartao.addEventListener('blur', () => {
  let [monthVal, yearVal] = validadeCartao.value.split('/');

  if (monthVal <= 12 && yearVal >= 24) {
    validadeCartao.parentElement.classList.remove('error-input');
    validadeCartao.parentElement.classList.add('right-input');
  } else {
    validadeCartao.parentElement.classList.add('error-input');
    validadeCartao.parentElement.classList.remove('right-input');
  }
});

const cvvCartao = document.getElementById('input-cvv-cartao');
cvvCartao.addEventListener('blur', () => {
  if (cvvCartao.value.length === 3) {
    cvvCartao.parentElement.classList.remove('error-input');
    cvvCartao.parentElement.classList.add('right-input');
  } else {
    cvvCartao.parentElement.classList.add('error-input');
    cvvCartao.parentElement.classList.remove('right-input');
  }
});

function validarCPF(cpf) {
  // Remove caracteres não numéricos
  cpf = cpf.replace(/[^\d]/g, '');

  // Verifica se o CPF tem 11 dígitos ou é uma sequência repetida (ex: 111.111.111-11)
  if (cpf.length !== 11 || /^(\d)\1{10}$/.test(cpf)) {
    return false;
  }

  // Função para calcular os dígitos verificadores
  const calcularDigito = (cpf, pesoInicial) => {
    let soma = 0;
    for (let i = 0; i < pesoInicial - 1; i++) {
      soma += parseInt(cpf[i]) * (pesoInicial - i);
    }
    const resto = soma % 11;
    return resto < 2 ? 0 : 11 - resto;
  };

  // Calcula os dois dígitos verificadores
  const digito1 = calcularDigito(cpf, 10);
  const digito2 = calcularDigito(cpf, 11);

  // Verifica se os dígitos calculados correspondem aos fornecidos
  return digito1 === parseInt(cpf[9]) && digito2 === parseInt(cpf[10]);
}

/* PAGAMENTOS  */
const btnsPagamentos = document.querySelectorAll('.div-btns-pagamentos a');
const tabsPagamentos = document.querySelectorAll('.tab-pagamento');

btnsPagamentos.forEach((btn, index) =>
  btn.addEventListener('click', () => {
    btnsPagamentos.forEach((elem) => elem.classList.remove('selected'));
    tabsPagamentos.forEach((tab) => tab.classList.remove('ativo'));

    btn.classList.add('selected');
    tabsPagamentos[index].classList.add('ativo');

    if (tabsPagamentos[index].classList.contains('tab-pagamento-pix')) {
      document.querySelector('.li-desconto-pix').classList.add('ativo');

      document.querySelector('#valor-total-cart').textContent =
        document.querySelector('#valor-frete-cart').textContent == '-'
          ? parseFloat(
              document
                .querySelector('#valor-subtotal-cart')
                .textContent.replace(',', '.'),
            )
              .toFixed(2)
              .replace('.', ',')
          : (
              parseFloat(
                document
                  .querySelector('#valor-subtotal-cart')
                  .textContent.replace(',', '.'),
              ) +
              parseFloat(
                document
                  .querySelector('#valor-frete-cart')
                  .textContent.replace('R$', '')
                  .replace(',', '.'),
              ) -
              parseFloat(
                document
                  .querySelector('#valor-desconto-pix')
                  .textContent.replace(',', '.'),
              )
            )
              .toFixed(2)
              .replace('.', ',')
              .replace('R$', '');
    } else {
      document.querySelector('.li-desconto-pix').classList.remove('ativo');
      document.querySelector('#valor-total-cart').textContent =
        document.querySelector('#valor-frete-cart').textContent == '-'
          ? parseFloat(
              document
                .querySelector('#valor-subtotal-cart')
                .textContent.replace(',', '.'),
            )
              .toFixed(2)
              .replace('.', ',')
          : (
              parseFloat(
                document
                  .querySelector('#valor-subtotal-cart')
                  .textContent.replace(',', '.'),
              ) +
              parseFloat(
                document
                  .querySelector('#valor-frete-cart')
                  .textContent.replace('R$', '')
                  .replace(',', '.'),
              )
            )
              .toFixed(2)
              .replace('.', ',')
              .replace('R$', '');
    }
  }),
);

const inputsCard = document.querySelectorAll('.input-qntd-cart');
const itemsProducts = document.querySelectorAll('.item-product-cart');
const priceFrete = document.querySelector('#valor-frete-cart');
const descontoPix = document.querySelector('#valor-desconto-pix');

function changeQntd(index, num) {
  if (parseInt(inputsCard[index].value) + num >= 1) {
    inputsCard[index].value = parseInt(inputsCard[index].value) + num;
    let totalQntdCart = 0;
    let totalPriceCart = 0;

    inputsCard.forEach((elem, i) => {
      totalQntdCart += parseInt(elem.value);
      totalPriceCart +=
        parseFloat(itemsProducts[i].dataset.price) * parseInt(elem.value);
    });
    document.querySelector('.quantidade-card-products').textContent =
      totalQntdCart;
    document.querySelector('#valor-subtotal-cart').textContent = totalPriceCart
      .toFixed(2)
      .replace('.', ',');

    descontoPix.textContent = (
      parseFloat(
        document
          .querySelector('#valor-subtotal-cart')
          .textContent.replace(',', '.'),
      ) * 0.05
    )
      .toFixed(2)
      .replace('.', ',');

    let valorTotal = parseFloat(totalPriceCart);
    if (priceFrete.textContent !== '-') {
      valorTotal += parseFloat(
        priceFrete.textContent.replace('R$', '').replace(',', '.'),
      );
      console.log(valorTotal);
    }

    if (descontoPix.parentElement.parentElement.classList.contains('ativo')) {
      valorTotal -= parseFloat(descontoPix.textContent.replace(',', '.'));
      console.log(valorTotal);
    }

    // document.querySelector('#valor-total-cart').textContent = priceFrete.textContent == '-' ? totalPriceCart.toFixed(2).replace('.', ',') : (parseFloat(totalPriceCart) + parseFloat(priceFrete.textContent.replace('R$', '').replace(',', '.'))).toFixed(2).replace('.', ',');

    document.querySelector('#valor-total-cart').textContent = valorTotal
      .toFixed(2)
      .replace('.', ',');
    document.querySelector('#valor-total-cart-header').textContent =
      document.querySelector('#valor-total-cart').textContent;
  } else {
    inputsCard[index].value = 1;
    descontoPix.textContent = (
      parseFloat(
        document
          .querySelector('#valor-subtotal-cart')
          .textContent.replace(',', '.'),
      ) * 0.05
    )
      .toFixed(2)
      .replace('.', ',');
  }
}

const btnToggleCart = document.querySelector('.btn-toggle-cart');
const bodyCart = document.querySelector('.body-cart-products');
const headerCart = document.querySelector('.header-cart-products');

btnToggleCart.addEventListener('click', () => {
  document.documentElement.style.setProperty(
    '--heightBodyCart',
    `${bodyCart.offsetHeight}px`,
  );

  bodyCart.classList.toggle('hide');
  headerCart.classList.toggle('hide-header');
});

function abrirModal(idModal) {
  fecharModais();

  document.querySelector('body').classList.add('modal-open');
  document.getElementById(idModal).classList.add('ativo');
}

function fecharModais() {
  document.querySelector('body').classList.remove('modal-open');

  document
    .querySelectorAll('.modal-container')
    .forEach((elem) => elem.classList.remove('ativo'));
  document
    .querySelectorAll('.alert')
    .forEach((elem) => elem.classList.remove('ativo'));
}

// Selecionar os elementos do cronômetro

