const linkDashboard = document.querySelectorAll('.link-dropdown');

linkDashboard.forEach((elem, i) => {
  elem.addEventListener('click', () => {
    linkDashboard.forEach((element, index) => {
      if (i !== index) element.parentElement.classList.remove('ativo');
    });
    elem.parentElement.classList.toggle('ativo');
  });
});

try {
  document
    .querySelector('.menu-item-logout a')
    .addEventListener('click', logoutUser);
} catch {}

function logoutUser() {
  localStorage.removeItem('authTokenVanillaCheckout');
  localStorage.removeItem('lastActiveTimeVanillaCheckout');
  window.location = 'https://vanillacheckout.com/login';
}

function checkTokenExpiration(token) {
  fetch(
    'https://recupera-fly-main-api.xwcabj.easypanel.host/recuperafly/transaction',
    {
      method: 'GET',
      headers: {
        Authorization: `Bearer ${token}`,
      },
    },
  )
    .then((response) => {
      if (response.status === 401) {
        document.querySelector('body').style.display = 'none';
        window.location = 'https://vanillacheckout.com/login';
        return true;
      } else {
        document.querySelector('body').style.display = 'block';
      }
      return false;
    })
    .catch((error) => {
      console.error('Erro ao enviar arquivo:', error);
      document.querySelector('body').style.display = 'none';
      window.location = 'https://vanillacheckout.com/login';

      return true;
    });
}

// Função para verificar o tempo de inatividade
function checkInactivity() {
  const now = new Date().getTime();
  const lastActiveTime = localStorage.getItem('lastActiveTimeVanillaCheckout');
  const inactivityLimit = 20 * 60 * 1000;

  if (lastActiveTime && now - lastActiveTime > inactivityLimit) {
    logoutUser();
  }
}

// Função para verificar o tempo restante
function checkSession() {
  const loginTime = localStorage.getItem('lastActiveTimeVanillaCheckout');
  if (loginTime) {
    const timeElapsed = Date.now() - parseInt(loginTime, 10);

    // Se já passou mais de 30 minutos (1800000ms), realizar o logout
    if (timeElapsed >= 30 * 60 * 1000) {
      logoutUser();
    }
  }
}

function setLogoutTimer() {
  const loginTime = localStorage.getItem('lastActiveTimeVanillaCheckout');
  if (loginTime) {
    const timeElapsed = Date.now() - parseInt(loginTime, 10);
    const timeRemaining = 30 * 60 * 1000 - timeElapsed;

    // Configura o timer
    setTimeout(() => {
      logoutUser();
    }, timeRemaining);
  }
}

// Verifica a sessão ao carregar a página
window.onload = function () {
  checkInactivity();

  if (!localStorage.getItem('authTokenVanillaCheckout')) {
    document.querySelector('body').style.display = 'none';
    window.location = 'https://vanillacheckout.com/login';
  }

  checkTokenExpiration(localStorage.getItem('authTokenVanillaCheckout'));
};

const params = new URLSearchParams(window.location.search);
if (params.get('token')) {
  localStorage.setItem('authTokenVanillaCheckout', params.get('token'));
  const now = new Date().getTime();
  localStorage.setItem('lastActiveTimeVanillaCheckout', now);

  window.location = '/home';
}
